## mediastreamer2 5.3.105+dfsg

=== CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

cmake_minimum_required(VERSION 3.22)

project(Mediastreamer2 VERSION 5.3.0 LANGUAGES C CXX)

if(WIN32)
    if( NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
        add_compile_definitions(_WIN32_WINNT=0x0601 _ALLOW_KEYWORD_MACROS)	#_WIN32_WINNT_WIN7
    endif()
endif()

# See: https://cmake.org/cmake/help/v3.12/policy/CMP0072.html
if(POLICY CMP0072)
	cmake_policy(SET CMP0072 NEW)
endif()

set(MEDIASTREAMER_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
set(MEDIASTREAMER_MINOR_VERSION ${PROJECT_VERSION_MINOR})
set(MEDIASTREAMER_MICRO_VERSION ${PROJECT_VERSION_PATCH})
set(MEDIASTREAMER_VERSION ${PROJECT_VERSION})
set(MEDIASTREAMER_SO_VERSION "11") # incremented for mediastreamer2-4.4.0

string(REGEX MATCH "^(arm*|aarch64)" FIXED_POINT_PROCESSOR "${CMAKE_SYSTEM_PROCESSOR}")
if(FIXED_POINT_PROCESSOR)
	set(ENABLE_FIXED_POINT_DEFAULT_VALUE YES)
else()
	set(ENABLE_FIXED_POINT_DEFAULT_VALUE NO)
endif()
if(IOS)
	set(ENABLE_MACSND_DEFAULT_VALUE NO)
	set(ENABLE_MACAQSND_DEFAULT_VALUE YES)
else()
	set(ENABLE_MACSND_DEFAULT_VALUE YES)
	set(ENABLE_MACAQSND_DEFAULT_VALUE NO)
endif()
set(ENABLE_GLX_DEFAULT_VALUE NO)
set(ENABLE_X11_DEFAULT_VALUE NO)
if(UNIX)
	if(NOT APPLE)
		set(ENABLE_GLX_DEFAULT_VALUE YES)
		set(ENABLE_X11_DEFAULT_VALUE YES)
	endif()
endif()
if(UNIX AND NOT APPLE AND NOT ANDROID)
	set(LINUX_OR_BSD 1)
endif()

include(CMakeDependentOption)

option(ENABLE_DEBUG_LOGS "Enable the display of traces showing the execution of the library." NO)
option(ENABLE_DOC "Enable documentation generation with Doxygen." YES)
option(ENABLE_FIXED_POINT "Turn on fixed point computations." ${ENABLE_FIXED_POINT_DEFAULT_VALUE})
option(ENABLE_NON_FREE_FEATURES "Allow inclusion of non-free features in the build." NO)
option(ENABLE_PCAP "Enable PCAP support." NO)
option(ENABLE_STRICT "Build with strict compile options." YES)
option(ENABLE_RELATIVE_PREFIX "Find resources relatively to the installation directory." NO)
option(ENABLE_TOOLS "Turn on or off compilation of tools." YES)
option(ENABLE_UNIT_TESTS "Enable compilation of unit tests." YES)
option(ENABLE_PACKAGE_SOURCE "Create 'package_source' target for source archive making" OFF)
option(ENABLE_OPENGL_PROFILING "Measure OpenGL render time (for performance profiling)" OFF)

option(ENABLE_SRTP "Build with the SRTP transport support." YES)
cmake_dependent_option(ENABLE_ZRTP "Build with ZRTP support." YES "ENABLE_SRTP" NO)
cmake_dependent_option(ENABLE_GOCLEAR "Build with ZRTP GoClear message support (RFC 6189 - section 5.11)." YES "ENABLE_ZRTP" NO)

option(ENABLE_SOUND "Can be used to turn off all possible sound backends." YES)
cmake_dependent_option(ENABLE_ALSA "Enable ALSA support." YES "ENABLE_SOUND;LINUX_OR_BSD" NO)
cmake_dependent_option(ENABLE_ANDROIDSND "Enable Android sound support." NO "ENABLE_SOUND;ANDROID" NO)
cmake_dependent_option(ENABLE_ARTSC "Enable artsc (KDE<4) sound input/output." NO "ENABLE_SOUND;LINUX_OR_BSD" NO)
cmake_dependent_option(ENABLE_MACSND "Enable MAC OS X Audio Units sound support." ${ENABLE_MACSND_DEFAULT_VALUE} "ENABLE_SOUND;APPLE" NO)
cmake_dependent_option(ENABLE_MACAQSND "Enable native MAC OS X Audio Queue sound support." ${ENABLE_MACAQSND_DEFAULT_VALUE} "ENABLE_SOUND;APPLE" NO)
cmake_dependent_option(ENABLE_QSA "Enable QSA (QNX Sound Architecture) support." NO "ENABLE_SOUND" NO)
# OSS is mostly deprecated in 2016, so it should not be built by default (it won't work anyway). Let user defines it
# itself only if he REALLY needs it.
cmake_dependent_option(ENABLE_OSS "Enable OSS support." NO "ENABLE_SOUND;LINUX_OR_BSD" NO)
cmake_dependent_option(ENABLE_PORTAUDIO "Enable portaudio native support." NO "ENABLE_SOUND" NO)
cmake_dependent_option(ENABLE_PULSEAUDIO "Enable pulseaudio support." YES "ENABLE_SOUND" NO)
option(ENABLE_G726 "Build mediastreamer2 with the G726 codec." NO)
option(ENABLE_GSM "Build mediastreamer2 with the GSM codec." YES)
option(ENABLE_BV16 "Build mediastreamer2 with the BV16 codec." YES)
option(ENABLE_OPUS "Build mediastreamer2 with the OPUS codec." YES)
option(ENABLE_SPEEX_CODEC "Build mediastreamer2 with the SPEEX codec." YES)
option(ENABLE_SPEEX_DSP "Build mediastreamer2 with the SPEEX DSP support." YES)
option(ENABLE_G729 "Build mediastreamer2 with the G729 codec." YES)
option(ENABLE_G729B_CNG "Build mediastreamer2 with G729 annex B cng." NO)
cmake_dependent_option(ENABLE_RESAMPLE "Build mediastreamer2 with the resampling capability." YES "ENABLE_SPEEX_DSP" NO)

option(ENABLE_VIDEO "Build mediastreamer2 with video support." YES)
option(ENABLE_QT_GL "Enable Qt OpenGL rendering support." OFF)
cmake_dependent_option(ENABLE_FFMPEG "Build mediastreamer2 with ffmpeg video support." YES "ENABLE_VIDEO" NO)
mark_as_advanced(ENABLE_FFMPEG)
cmake_dependent_option(ENABLE_GL "Enable generic OpenGL rendering support." YES "ENABLE_VIDEO" NO)
cmake_dependent_option(ENABLE_GLX "Enable X11+OpenGL rendering support (requires glx and glew)." ${ENABLE_GLX_DEFAULT_VALUE} "ENABLE_VIDEO;UNIX" NO)
cmake_dependent_option(ENABLE_SDL "Enable SDL support." NO "ENABLE_FFMPEG" NO)
cmake_dependent_option(ENABLE_V4L "Enable Video4Linux support." YES "ENABLE_VIDEO;LINUX_OR_BSD" NO)
cmake_dependent_option(ENABLE_X11 "Enable X11 support." ${ENABLE_X11_DEFAULT_VALUE} "ENABLE_VIDEO;UNIX" NO)
cmake_dependent_option(ENABLE_XV "Enable XV support." ${ENABLE_X11_DEFAULT_VALUE} "ENABLE_VIDEO;UNIX" NO)
cmake_dependent_option(ENABLE_THEORA "Enable theora video codec support." YES "ENABLE_VIDEO" NO)
cmake_dependent_option(ENABLE_VPX "Build mediastreamer2 with VPX codec." YES "ENABLE_VIDEO" NO)
cmake_dependent_option(ENABLE_LIBYUV "Build mediastreamer2 with LibYUV support." YES "ENABLE_VIDEO" NO)
option(ENABLE_MKV "Enable support of MKV files reading and writing." YES)
cmake_dependent_option(ENABLE_QNX "Build medistreamer2 with BB10 filters." NO "ENABLE_VIDEO" NO)
option(ENABLE_JPEG "Enable JPEG support" YES)
cmake_dependent_option(ENABLE_QRCODE "Enable QRCode support" YES "ENABLE_VIDEO" NO)
cmake_dependent_option(ENABLE_AV1 "Build mediastreamer2 with AV1 support." YES "ENABLE_VIDEO" NO)


set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_EXTENSIONS NO)

list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

include(CheckIncludeFile)
include(CheckLibraryExists)
include(CMakePushCheckState)
include(GNUInstallDirs)

if(NOT CMAKE_INSTALL_RPATH AND CMAKE_INSTALL_PREFIX)
	set(CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
	message(STATUS "Setting install rpath to ${CMAKE_INSTALL_RPATH}")
endif()

check_include_file(sys/shm.h HAVE_SYS_SHM_H)
check_include_file(alloca.h HAVE_ALLOCA_H)
if(ENABLE_OSS)
	check_include_file(soundcard.h HAVE_SOUNDCARD_H)
	check_include_file(sys/soundcard.h HAVE_SYS_SOUNDCARD_H)
	check_include_file(machine/soundcard.h HAVE_MACHINE_SOUNDCARD_H)
	check_include_file(sys/audio.h HAVE_SYS_AUDIO_H)
	if(NOT (HAVE_SOUNDCARD_H OR HAVE_SYS_SOUNDCARD_H OR HAVE_MACHINE_SOUNDCARD_H OR HAVE_SYS_AUDIO_H))
		set(ENABLE_OSS OFF CACHE BOOL "Enable OSS support." FORCE)
	endif()
endif()

check_library_exists("dl" "dlopen" "" HAVE_DLOPEN)

include(TestBigEndian)
test_big_endian(WORDS_BIGENDIAN)

find_package(Ortp 5.3.0 REQUIRED)

if(ENABLE_PCAP)
	find_package(PCAP)
endif()
if(ENABLE_SRTP)
	find_package(SRTP 2 REQUIRED)
endif()
if(ENABLE_ZRTP)
	find_package(BZRTP 5.3.0 REQUIRED)
endif()
if(ENABLE_G726)
	find_package(SpanDSP REQUIRED)
endif()
if(ENABLE_GSM)
	find_package(GSM)
	if(NOT GSM_FOUND)
		message(WARNING "Could not find GSM library, mediastreamer2 will be compiled without the GSM codec.")
		set(ENABLE_GSM OFF CACHE BOOL "Build mediastreamer2 with the GSM codec." FORCE)
	endif()
endif()
if(ENABLE_BV16)
	find_package(BV16)
	if(NOT BV16_FOUND)
		message(WARNING "Could not find BV16 library, mediastreamer2 will be compiled without the BV16 codec.")
		set(ENABLE_BV16 OFF CACHE BOOL "Build mediastreamer2 with the BV16 codec." FORCE)
	endif()
endif()
if(ENABLE_OPUS)
	find_package(Opus)
	if(NOT Opus_FOUND)
		message(WARNING "Could not find opus library, mediastreamer2 will be compiled without the OPUS codec.")
		set(ENABLE_OPUS OFF CACHE BOOL "Build mediastreamer2 with the OPUS codec." FORCE)
	endif()
endif()
if(ENABLE_SPEEX_CODEC)
	find_package(Speex)
	if(NOT Speex_FOUND)
		message(WARNING "Could not find speex library, mediastreamer2 will be compiled without the SPEEX codec.")
		set(ENABLE_SPEEX_CODEC OFF CACHE BOOL "Build mediastreamer2 with the SPEEX codec." FORCE)
	endif()
endif()
if(ENABLE_SPEEX_DSP)
	find_package(SpeexDSP REQUIRED)
endif()
if(ENABLE_ALSA)
	find_package(ALSA)
	if(NOT ALSA_FOUND)
		set(ENABLE_ALSA OFF CACHE BOOL "Enable ALSA support." FORCE)
	endif()
endif()
if(ENABLE_ARTSC)
	find_package(Arts REQUIRED)
endif()
if(ENABLE_PORTAUDIO)
	find_package(PortAudio REQUIRED)
endif()
if(ENABLE_PULSEAUDIO)
	find_package(PulseAudio)
	if(NOT PulseAudio_FOUND)
		set(ENABLE_PULSEAUDIO OFF CACHE BOOL "Enable pulseaudio support." FORCE)
	endif()
endif()
if(ENABLE_QSA)
	find_package(QSA REQUIRED)
	find_package(QnxAudioManager REQUIRED)
endif()
if(ENABLE_VIDEO)
	add_definitions(-DVIDEO_ENABLED)
endif()
if(ENABLE_FFMPEG)
	find_package(FFMpeg REQUIRED)
else()
	add_definitions(-DNO_FFMPEG)
endif()
if(ENABLE_V4L)
	find_package(V4L)
	if(NOT V4L_FOUND)
		message(FATAL_ERROR "Missing V4L. It is highly recommended to build with libv4l2 headers and library. Many camera will won't work or will crash your application if libv4l2 is not installed. If you know what you are doing, you can use -DENABLE_V4L=0 to disable this check.")
	endif()
endif()
if(ENABLE_X11)
	find_package(X11)
	if(NOT X11_FOUND)
		set(ENABLE_X11 OFF CACHE BOOL "Enable X11 support." FORCE)
	elseif(X11_Xlib_INCLUDE_PATH)
		set(HAVE_X11_XLIB_H 1)
	endif()
endif()
if(ENABLE_XV AND ENABLE_X11)
	find_package(X11)
	if(X11_Xv_FOUND)
		set(HAVE_XV 1)
	else()
		set(HAVE_XV 0)
		set(ENABLE_XV OFF CACHE BOOL "Enable XV support." FORCE)
	endif()
else()
	set(HAVE_XV 0)
endif()
if(ENABLE_GL)
	if(WIN32)
		find_package(QtAngle)
		set(HAVE_GL 1)
		if(NOT QtAngle_FOUND) # QtAngle is not found so we use internal files
			include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OpenGL")
		endif()
	else()
		find_package(OpenGL)
		if(OPENGL_FOUND)
			set(HAVE_GL 1)
			include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OpenGL")
		else()
			set(ENABLE_GL OFF CACHE BOOL "Enable generic OpenGL rendering support." FORCE)
		endif()
	endif()
endif()

if(ENABLE_VIDEO AND APPLE)
	include_directories("${CMAKE_CURRENT_SOURCE_DIR}/include/OpenGL")
endif()
if(ENABLE_GLX)
	find_package(OpenGL COMPONENTS GLX)
	if(OpenGL_GLX_FOUND)
		set(HAVE_GLX 1)
	else()
		set(ENABLE_GLX OFF CACHE BOOL "Enable X11+OpenGL rendering support (requires glx and glew)." FORCE)
	endif()
endif()
if(NOT APPLE AND NOT ANDROID AND OPENGL_FOUND OR OpenGL_GLX_FOUND)	
	set(GLEW_VERBOSE 1)
	include(FindGLEW) # Use cmake find in place of find_package(Glew REQUIRED)
	if(NOT GLEW_FOUND)
		message(FATAL_ERROR "Glew is missing. Mediastreamer2 need it")
	endif()

=== build/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

if(NOT CPACK_PACKAGE_NAME)
	string(TOLOWER "${PROJECT_NAME}" LOWERCASE_PROJECT_NAME)
	set(CPACK_PACKAGE_NAME "${LOWERCASE_PROJECT_NAME}")
endif()

set(CPACK_SOURCE_IGNORE_FILES
	"${CMAKE_BINARY_DIR}"
	"^${PROJECT_SOURCE_DIR}/.git*"
)

bc_make_package_source_target()

=== help/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

find_package(Doxygen)

if(DOXYGEN_FOUND)
	if(DOXYGEN_DOT_FOUND)
                set(top_srcdir ${PROJECT_SOURCE_DIR})
		configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile)
		file(GLOB DOC_INPUT_FILES
			[^.]*.dox
			../include/mediastreamer2/[^.]*.h
			src/[^.]*/[^.]*.h
			src/[^.]*/[^.]*.c
		)
		add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html"
			COMMAND ${DOXYGEN_EXECUTABLE} ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile
			DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile ${DOC_INPUT_FILES}
		)
		add_custom_target(mediastreamer2-html-doc ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/doc/html/index.html")
		install(DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/doc/html"
			DESTINATION "${CMAKE_INSTALL_DATADIR}/doc/mediastreamer2-${MEDIASTREAMER_VERSION}")
	else()
		message(WARNING "The dot program is needed to generate the mediastreamer2 documentation. You can get it from http://www.graphviz.org/.")
	endif()
endif()

=== include/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(HEADER_FILES
	allfilters.h
	android_utils.h
	bitratecontrol.h
	bits_rw.h
	box-plot.h
	devices.h
	dsptools.h
	dtls_srtp.h
	dtmfgen.h
	flowcontrol.h
	formats.h
	ice.h
	mediastream.h
	ms_srtp.h
	msaudiomixer.h
	mschanadapter.h
	mscodecutils.h
	mscommon.h
	msconference.h
	msequalizer.h
	mseventqueue.h
	msextdisplay.h
	msanalysedisplay.h
	msfactory.h
	msfileplayer.h
	msfilerec.h
	msfilter.h
	msgenericplc.h
	msinterfaces.h
	msitc.h
	msjava.h
	msjpegwriter.h
	msogl.h
	msogl_functions.h
	msqrcodereader.h
	msmediaplayer.h
	msmediarecorder.h
	msqueue.h
	msrtp.h
	mssndcard.h
	mstee.h
	msticker.h
	mstonedetector.h
	msutils.h
	msv4l.h
	msvaddtx.h
	msvideo.h
	msvideoout.h
	msvideopresets.h
	msvideoqualitycontroller.h
	msvolume.h
	mswebcam.h
	qualityindicator.h
	rfc3984.h
	stun.h
	upnp_igd.h
	x11_helper.h
	zrtp.h
	msrtt4103.h
	msasync.h
	msudp.h
	mspcapfileplayer.h
	msanalysedisplay.h
	msmire.h
	msvideorouter.h
)

set(MEDIASTREAMER2_HEADER_FILES )
foreach(HEADER_FILE ${HEADER_FILES})
	list(APPEND MEDIASTREAMER2_HEADER_FILES "${CMAKE_CURRENT_LIST_DIR}/mediastreamer2/${HEADER_FILE}")
endforeach()
set(MEDIASTREAMER2_HEADER_FILES ${MEDIASTREAMER2_HEADER_FILES} PARENT_SCOPE)

install(FILES ${MEDIASTREAMER2_HEADER_FILES}
	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/mediastreamer2
	PERMISSIONS OWNER_READ OWNER_WRITE GROUP_READ WORLD_READ
)
if(ENABLE_VIDEO)
	install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/OpenGL
		DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	)

endif()

=== src/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

find_library(LIBM NAMES m)

find_program(AWK_PROGRAM awk)
if(NOT AWK_PROGRAM)
	message(FATAL_ERROR "You need the awk program to build mediastreamer2.")
endif()

set(BASE_SOURCE_FILES_C
	base/eventqueue.c
	base/mscommon.c
	base/msfactory.c
	base/msfilter.c
	base/msqueue.c
	base/mssndcard.c
	base/msticker.c
	base/msvideopresets.c
	base/mswebcam.c
	base/mtu.c
	base/msasync.c
	otherfilters/itc.c
	otherfilters/join.c
	otherfilters/tee.c
	otherfilters/void.c
)
if(ANDROID)
	list(APPEND BASE_SOURCE_FILES_C utils/msjava.c)
endif()

bc_git_version(mediastreamer2 ${PROJECT_VERSION})

add_definitions(
	-D_TRUE_TIME
	-DMS2_EXPORTS
	-DMS2_INTERNAL
	-DMS2_FILTERS
)
if(SRTP_NOT_INSTALLED)
	# Set -DSRTP_INTERNAL in order to include srtp.h instead of srtp2/srtp.h
	add_compile_definitions(SRTP_INTERNAL)
endif()

set(VOIP_SOURCE_FILES_C
	audiofilters/alaw.c
	audiofilters/audiomixer.c
	audiofilters/chanadapt.c
	audiofilters/devices.c
	audiofilters/dtmfgen.c
	audiofilters/equalizer.c
	audiofilters/flowcontrol.c
	audiofilters/g711.c
	audiofilters/g711.h
	audiofilters/genericplc.h
	audiofilters/genericplc.c
	audiofilters/msgenericplc.c
	audiofilters/l16.c
	audiofilters/msfileplayer.c
	audiofilters/msfilerec.c
	audiofilters/asyncrw.c
	audiofilters/asyncrw.h
	audiofilters/msg722.c
	audiofilters/msvaddtx.c
	audiofilters/msvolume.c
	audiofilters/tonedetector.c
	audiofilters/ulaw.c
	audiofilters/waveheader.h
	crypto/zrtp.c
	otherfilters/msrtp.c
	utils/_kiss_fft_guts.h
	utils/audiodiff.c
	utils/box-plot.c
	utils/dsptools.c
	utils/g722.h
	utils/g722_decode.c
	utils/g722_encode.c
	utils/kiss_fft.c
	utils/kiss_fft.h
	utils/kiss_fftr.c
	utils/kiss_fftr.h
	utils/pcap_sender.c
	utils/pcap_sender.h
	utils/stream_regulator.c
	utils/srtp_prefix.h
	voip/audioconference.c
	voip/audiostream.c
	voip/bandwidthcontroller.c
	voip/bitratecontrol.c
	voip/bitratedriver.c
	voip/ice.c
	voip/mediastream.c
	voip/msiframerequestslimiter.c
	voip/msmediaplayer.c
	voip/msmediarecorder.c
	voip/msvoip.c
	voip/private.h
	voip/qosanalyzer.c
	voip/qosanalyzer.h
	voip/qualityindicator.c
	otherfilters/rfc4103_source.c
	otherfilters/rfc4103_sink.c
	otherfilters/msudp.c
	voip/rfc4103_textstream.c
	voip/ringstream.c
	voip/stun.c
	voip/offeranswer.c
	voip/private.h
)
set(VOIP_SOURCE_FILES_CXX
	crypto/dtls_srtp.cpp
	utils/filter-wrapper/decoding-filter-wrapper.cpp
	utils/filter-wrapper/encoding-filter-wrapper.cpp
	voip/audiostreamvolumes.cpp
	voip/turn_tcp.cpp
	voip/video-conference.cpp
	voip/video-conference-all-to-all.cpp
	voip/video-endpoint.cpp
	crypto/ms_srtp.cpp
)
set(VOIP_SOURCE_FILES_OBJC )
set(VOIP_SOURCE_FILES_ASM )

if (APPLE)
        list(APPEND VOIP_SOURCE_FILES_OBJC utils/apple_utils.h utils/apple_utils.m)
endif()

if(ENABLE_ALSA)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/alsa.c)
endif()
if(ANDROID)
	list(APPEND VOIP_SOURCE_FILES_CXX voip/msvoip_jni.cc)
endif()
if(ENABLE_ANDROIDSND)
	list(APPEND VOIP_SOURCE_FILES_CXX
		android/androidsound_utils.cpp
		android/androidsound_utils_depr.cpp
		android/androidsound.cpp
		android/androidsound_depr.cpp
		android/androidsound_opensles.cpp
		android/AudioRecord.cpp
		android/AudioSystem.cpp
		android/AudioTrack.cpp
		android/hardware_echo_canceller.cpp
		android/loader.cpp
		android/String8.cpp
		#audiofilters/aac-eld-android.cpp
		#Not working on Android, to be fix
	)
endif()
if(ENABLE_ARTSC)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/arts.c)
endif()
if(ENABLE_MACSND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/macsnd.c)
endif()
if(ENABLE_MACAQSND)
	list(APPEND VOIP_SOURCE_FILES_OBJC audiofilters/aqsnd.m)
endif()
if(ENABLE_OSS)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/oss.c)
endif()
if(ENABLE_PORTAUDIO)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/pasnd.c)
endif()
if(ENABLE_PULSEAUDIO)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/pulseaudio.c)
endif()
if(ENABLE_QSA)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/qsa.c)
endif()
if(APPLE)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/aac-eld.c)
endif()
if(IOS)
	list(APPEND VOIP_SOURCE_FILES_OBJC audiofilters/msiounit.mm)
endif()

if(ENABLE_G726)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/g726.c)
endif()
if(BCG729_FOUND AND ENABLE_G729)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/g729.c)
endif()
if(GSM_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/gsm.c)
	if(GSM_USE_BUILD_INTERFACE)
		set_source_files_properties("audiofilters/gsm.c" PROPERTIES COMPILE_DEFINITIONS "GSM_USE_BUILD_INTERFACE")
	endif()
endif()
if(BV16_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/bv16.c)
endif()
if(Opus_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msopus.c)
	if(Opus_USE_BUILD_INTERFACE)
		set_source_files_properties("audiofilters/msopus.c" PROPERTIES COMPILE_DEFINITIONS "OPUS_USE_BUILD_INTERFACE")
	endif()
endif()
if(ENABLE_RESAMPLE)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msresample.c)
endif()
if(Speex_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/msspeex.c)
endif()
if(SpeexDSP_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C audiofilters/speexec.c)
endif()

if(ENABLE_VIDEO)
	list(APPEND VOIP_SOURCE_FILES_C
		utils/bits_rw.c
		videofilters/extdisplay.c
		videofilters/msanalysedisplay.c
		videofilters/mire.c
		videofilters/nowebcam.c
		videofilters/pixconv.c
		videofilters/sizeconv.c
		videofilters/videorouter.c
		videofilters/dummy_codec.c
		voip/layouts.c
		voip/layouts.h
		voip/msvideo_neon.c
		voip/msvideo_neon.h
		voip/msvideo.c
		voip/msvideoqualitycontroller.c
		voip/nowebcam.h
		voip/rfc2429.h
		voip/video_preset_high_fps.c
		voip/videostarter.c
		voip/videostream.c
		voip/vp8rtpfmt.c
		voip/vp8rtpfmt.h
	)
	if(FFMpeg_FOUND AND NOT TurboJpeg_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-ffmpeg.c
		)
	elseif(TurboJpeg_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-turbojpeg.c
		)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/msturbojpeg.cpp	# MJPEG using turbojpeg
		)
	else()
		list(APPEND VOIP_SOURCE_FILES_C
			utils/jpgloader-stub.c
		)
	endif()
	if(ENABLE_QT_GL)
		set(QT_VOIP_SOURCE_FILES_CXX videofilters/msqogl.cpp )
	endif()
	if(WIN32)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/msmfoundationcap.cpp	#Media-Foundation
			videofilters/msmfoundationcap.h
		)
	    if(NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsPhone" AND NOT CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
			add_definitions(-DHAVE_DIRECTSHOW)
			if(NOT(ENABLE_MICROSOFT_STORE_APP))
				list(APPEND VOIP_SOURCE_FILES_C videofilters/drawdib-display.c)
			endif()
			list(APPEND VOIP_SOURCE_FILES_CXX
				videofilters/msdscap.cc				#DirectShow
			)
		elseif(CMAKE_SYSTEM_NAME STREQUAL "WindowsStore")
			set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} /ZW /EHsc /await")
	    endif()
	endif()
	if(APPLE)
		if(IOS)
			list(APPEND VOIP_SOURCE_FILES_C
				utils/opengl_functions.c
				utils/opengl_functions.h
				utils/opengles_display.c
				utils/opengles_display.h
				utils/shader_util.c
				utils/shader_util.h
			)
			list(APPEND VOIP_SOURCE_FILES_OBJC
				videofilters/iosdisplay.mm
				videofilters/ioscapture.m
				voip/ioshardware.m
			)
		else()
			list(APPEND VOIP_SOURCE_FILES_OBJC
				videofilters/msosxdisplay.m
				videofilters/avfound-capture.m
			)

			list(APPEND VOIP_SOURCE_FILES_C
				utils/opengl_functions.c
				utils/opengl_functions.h
				utils/opengles_display.c
				utils/opengles_display.h
				utils/shader_util.c
				utils/shader_util.h
			)
		endif()
	endif()
	if(ANDROID)
		list(APPEND VOIP_SOURCE_FILES_C
			android/android-display.c
			android/android-opengl-display.c
			android/android-texture-display.c
			utils/opengl_functions.c
			utils/opengl_functions.h
			utils/opengles_display.c
			utils/opengles_display.h
			utils/shader_util.c
			utils/shader_util.h
		)
		if(CMAKE_SYSTEM_PROCESSOR STREQUAL "armv7-a")
			list(APPEND VOIP_SOURCE_FILES_ASM
				voip/scaler_arm.S
			)
		endif()
		list(APPEND VOIP_SOURCE_FILES_CXX
			android/android_mediacodec.cpp
			android/android-display-bad.cpp
			android/androidvideo.cpp
		)
	endif()
	if (ENABLE_QNX)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/bb10_display.cpp
			videofilters/bb10_capture.cpp
		)
	endif()
	if(FFMpeg_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/ffmpeg-priv.c
			utils/ffmpeg-priv.h
			videofilters/videodec.c
			videofilters/videoenc.c
		)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/h264dec.cpp
		)
		if(NOT TurboJpeg_FOUND)
			list(APPEND VOIP_SOURCE_FILES_C
				videofilters/ffmpegjpegwriter.c
			)
		endif()
	endif()
	if(TurboJpeg_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/turbojpegwriter.c
		)
	endif()
	if(ZXing_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/zxing_qrcode.cpp
		)
		set_source_files_properties("videofilters/zxing_qrcode.cpp" PROPERTIES INCLUDE_DIRECTORIES "${ZXING_INCLUDE_DIRS}")
		if(ZXing_USE_BUILD_INTERFACE)
			set_source_files_properties("videofilters/zxing_qrcode.cpp" PROPERTIES COMPILE_DEFINITIONS "ZXING_USE_BUILD_INTERFACE")
		endif()
	endif()
	if(WIN32)
		list(APPEND VOIP_SOURCE_FILES_CXX
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/generic_opengl_display.c
		)
	elseif(OPENGL_FOUND OR QtAngle_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/generic_opengl_display.c
		)
	endif()
	if(OpenGL_GLX_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			utils/opengl_functions.c
			utils/opengles_display.c
			utils/shader_util.c
			videofilters/glxvideo.c
		)
	endif()
	if(SDL_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/videoout.c)
	endif()
	if(Theora_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/theora.c)
	endif()
	if(V4L_FOUND)
		if(HAVE_LINUX_VIDEODEV_H)
			list(APPEND VOIP_SOURCE_FILES_C videofilters/msv4l.c)
		endif()
		if(HAVE_LINUX_VIDEODEV2_H)
			list(APPEND VOIP_SOURCE_FILES_C videofilters/msv4l2.c)
		endif()
	endif()
	if(VPX_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C
			videofilters/vp8.c
		)
	endif()
	if(X11_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C utils/x11_helper.c)
	endif()
	if(X11_Xv_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/x11video.c)
	endif()
	if(Dav1d_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/av1/decoder/av1-decoder.cpp
			videofilters/av1/decoder/av1-decoder-filter.cpp
		)
	endif()
	if(Aom_FOUND)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/av1/encoder/av1-encoder.cpp
			videofilters/av1/encoder/av1-encoder-filter.cpp
		)
	endif()
	if(Dav1d_FOUND OR Aom_FOUND)
		list(APPEND VOIP_SOURCE_FILES_C videofilters/av1/obu/obuparse.c)
		list(APPEND VOIP_SOURCE_FILES_CXX
			videofilters/av1/obu/obu-key-frame-indicator.cpp
			videofilters/av1/obu/obu-packer.cpp
			videofilters/av1/obu/obu-unpacker.cpp
		)
	endif()
endif()
if(BCMatroska2_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C
		voip/rfc2429.h
	)
	list(APPEND VOIP_SOURCE_FILES_CXX
		utils/mkv_reader.cpp
		videofilters/mkv.cpp
	)
endif()

if(PCAP_FOUND)
	list(APPEND VOIP_SOURCE_FILES_C otherfilters/mspcapfileplayer.c)
endif()

=== tools/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2023 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

set(USE_BUNDLE )
if (IOS)
	set(USE_BUNDLE MACOSX_BUNDLE)
endif()

set(MS2_LIBS_FOR_TOOLS mediastreamer2)
if(X11_FOUND)
	list(APPEND MS2_LIBS_FOR_TOOLS X11::X11)
endif()
if(X11_Xext_FOUND)
	list(APPEND MS2_LIBS_FOR_TOOLS X11::Xext)
endif()
if(X11_Xv_FOUND)
	list(APPEND MS2_LIBS_FOR_TOOLS X11::Xv)
endif()
if(TurboJpeg_FOUND)
	list(APPEND MS2_LIBS_FOR_TOOLS ${TurboJpeg_TARGET})
endif()

set(simple_executables bench ring mtudiscover tones msaudiocmp)
if(ENABLE_VIDEO)
	list(APPEND simple_executables videodisplay)
	if(X11_FOUND)
		list(APPEND simple_executables test_x11window)
	endif()
endif()

foreach(simple_executable ${simple_executables})
	set(${simple_executable}_SOURCE_FILES ${simple_executable}.c)
	bc_apply_compile_flags(${simple_executable}_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(mediastreamer2-${simple_executable} ${USE_BUNDLE} ${simple_executable}.c)
	target_link_libraries(mediastreamer2-${simple_executable} ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	set_target_properties(mediastreamer2-${simple_executable} PROPERTIES LINKER_LANGUAGE CXX)
endforeach()

set(ECHO_SOURCE_FILES echo.c)
bc_apply_compile_flags(ECHO_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
add_executable(mediastreamer2-echo ${USE_BUNDLE} ${ECHO_SOURCE_FILES}) # Do not name the target "echo" to avoid conflict with the shell echo command
set_target_properties(mediastreamer2-echo PROPERTIES LINKER_LANGUAGE CXX)
target_link_libraries(mediastreamer2-echo ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})

if(PCAP_FOUND)
	if(APPLE AND NOT IOS)
		set(SOURCE_FILES_OBJC pcap_player_cocoa.m)
	endif()
	bc_apply_compile_flags(SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)

	set(PCAP_PLAYBACK_SOURCE_FILES pcap_playback.c common.c)
	bc_apply_compile_flags(PCAP_PLAYBACK_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(mediastreamer2-pcap-playback ${USE_BUNDLE} ${PCAP_PLAYBACK_SOURCE_FILES} ${SOURCE_FILES_OBJC})
	set_target_properties(mediastreamer2-pcap-playback PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(mediastreamer2-pcap-playback ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
endif()

if (NOT IOS)
	set(MEDIASTREAM_SOURCE_FILES_C mediastream.c common.c)
	set(MEDIASTREAM_SOURCE_FILES_OBJC )
	if(APPLE)
		list(APPEND MEDIASTREAM_SOURCE_FILES_OBJC mediastream_cocoa.m)
	endif()
	bc_apply_compile_flags(MEDIASTREAM_SOURCE_FILES_C STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	bc_apply_compile_flags(MEDIASTREAM_SOURCE_FILES_OBJC STRICT_OPTIONS_CPP STRICT_OPTIONS_OBJC)
	add_executable(mediastreamer2-mediastream ${USE_BUNDLE} ${MEDIASTREAM_SOURCE_FILES_C} ${MEDIASTREAM_SOURCE_FILES_OBJC})
	set_target_properties(mediastreamer2-mediastream PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(mediastreamer2-mediastream ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})
	install(TARGETS mediastreamer2-mediastream
		RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
	)
endif()

if(ENABLE_VIDEO)
	set(MKVSTREAM_SOURCE_FILES mkvstream.c)
	bc_apply_compile_flags(MKVSTREAM_SOURCE_FILES STRICT_OPTIONS_CPP STRICT_OPTIONS_C)
	add_executable(mediastreamer2-mkvstream ${USE_BUNDLE} ${MKVSTREAM_SOURCE_FILES})
	set_target_properties(mediastreamer2-mkvstream PROPERTIES LINKER_LANGUAGE CXX)
	target_link_libraries(mediastreamer2-mkvstream ${MS2_LIBS_FOR_TOOLS} ${LINK_LIBS})

	if (NOT IOS)
		install(TARGETS mediastreamer2-mkvstream
			RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
		)
	endif()
endif()

=== src/videofilters/h26x/CMakeLists.txt ===
############################################################################
# Copyright (c) 2010-2022 Belledonne Communications SARL.
#
# This file is part of mediastreamer2 
# (see https://gitlab.linphone.org/BC/public/mediastreamer2).
#
############################################################################
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as
# published by the Free Software Foundation, either version 3 of the
# License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program. If not, see <http://www.gnu.org/licenses/>.
############################################################################

list(APPEND VOIP_SOURCE_FILES_CXX
	${CMAKE_CURRENT_SOURCE_DIR}/h26x-encoder-filter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h26x-decoder-filter.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h26x-utils.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h264-nal-packer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h264-nal-unpacker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h264-utils.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h265-nal-packer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h265-nal-unpacker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/h265-utils.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/nal-packer.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/nal-unpacker.cpp
	${CMAKE_CURRENT_SOURCE_DIR}/rfc3984.cpp
)

if(APPLE)
	list(APPEND VOIP_SOURCE_FILES_CXX
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox-decoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox-encoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox-utils.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox-h264-utilities.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/videotoolbox-h265-utilities.cpp
	)
endif()

if(ANDROID)
	list(APPEND VOIP_SOURCE_FILES_CXX
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-decoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-encoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-h264-decoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-h264-encoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-h265-decoder.cpp
		${CMAKE_CURRENT_SOURCE_DIR}/media-codec-h265-encoder.cpp
	)
endif()

set(VOIP_SOURCE_FILES_CXX ${VOIP_SOURCE_FILES_CXX} PARENT_SCOPE)

=== debian/changelog ===
mediastreamer2 (1:5.3.105+dfsg-5build2) resolute; urgency=medium

  * Rebuild against latest libvpx

 -- Jeremy Bícha <jbicha@ubuntu.com>  Sun, 02 Nov 2025 11:17:23 -0500

mediastreamer2 (1:5.3.105+dfsg-5build1) questing; urgency=medium

  * No-change rebuild against Qt 5.15.17.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Sun, 13 Jul 2025 10:57:18 +0300

mediastreamer2 (1:5.3.105+dfsg-5) unstable; urgency=medium

  * Team upload
  * Only depend on srtp2 for arch-any build
  * Extend the build profile patch

 -- Bastian Germann <bage@debian.org>  Thu, 27 Feb 2025 11:33:18 +0100

mediastreamer2 (1:5.3.105+dfsg-4) unstable; urgency=medium

  * Team upload
  * Fix build-all

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 23:11:35 +0100

mediastreamer2 (1:5.3.105+dfsg-3) unstable; urgency=medium

  * Team upload
  * Add directory referenced in Mediastreamer2Config.cmake

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 22:15:39 +0100

mediastreamer2 (1:5.3.105+dfsg-2) unstable; urgency=medium

  * Team upload
  * Disable NEON on ARM
  * Prevent unknown pragma and unused variable errors

 -- Bastian Germann <bage@debian.org>  Wed, 26 Feb 2025 21:34:40 +0100

mediastreamer2 (1:5.3.105+dfsg-1) unstable; urgency=medium

  [ Victor Seva ]
  * Add myself to Uploaders. Remove Tzafrir. wrap-and-sort -sat
  * debian/gbp.conf: switch to DEP-14 layout
  * New upstream version 5.3.105+dfsg
  * Trim trailing whitespace.
  * Refer to common license file for Apache-2.0.
  * Set upstream metadata fields: Repository-Browse.
  * Remove unused license definitions for LGPL-2.1+.
  * Remove field Section on binary package
    libmediastreamer-data that duplicates source.
  * Avoid explicitly specifying -Wl,--as-needed linker flag.
  * debian/gbp.conf: filter tester dir
  * rework patches
  * debian/rules: remove features not supported anymore
  * shared lib is now libmediastreamer2
  * pkg-config => pkgconf
  * debian/copyright: remove files no longer in the repo
  * Set upstream metadata fields: Repository.
  * debian/control: fix short description too long
  * debian/copyright: add myself in debian/*

  [ Dennis Filder ]
  * Advance linphone stack dependencies
  * Bump SO version due to ABI break
  * Use DEB_HOST_GNU_TYPE instead of DEB_HOST_MULTIARCH in CMake build paths
  * Update d/rules for the new soname; add early sanity check
  * Add debian/shlibs.local for tighter version linkage to bcmatroska2
  * Add another shlibs.local entry for libortp
  * Add shlibs.local entry for libbzrtp

 -- Victor Seva <vseva@debian.org>  Sun, 23 Feb 2025 00:13:24 +0100

mediastreamer2 (1:5.2.0+dfsg-4) unstable; urgency=medium

  * Team upload. (Closes: #1068917)
  * d/copyright: Use correct case for public-domain.

 -- Bastian Germann <bage@debian.org>  Sat, 13 Apr 2024 11:28:49 +0000

mediastreamer2 (1:5.2.0+dfsg-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1064170

 -- Steve Langasek <vorlon@debian.org>  Fri, 05 Apr 2024 23:48:00 +0000

=== debian/control ===
Source: mediastreamer2
Priority: optional
Maintainer: Debian VoIP Team <pkg-voip-maintainers@lists.alioth.debian.org>
Uploaders:
 Kilian Krause <kilian@debian.org>,
 Victor Seva <vseva@debian.org>,
 Felix Lechner <felix.lechner@gmail.com>,
 Bernhard Schmidt <berni@debian.org>,
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libortp-dev (>= 1:5.3.104~),
Build-Depends-Indep:
 doxygen <!nodoc>,
 graphviz <!nodoc>,
Build-Depends-Arch:
 libasound2-dev [linux-any],
 libavcodec-dev (>= 6:10~),
 libavutil-dev (>= 6:10~),
 libbcg729-dev (>= 1.1.1~),
 libbcmatroska2-dev (>= 5.3.101~),
 libbctoolbox-dev (>= 5.3.101~),
 libbzrtp-dev (>= 5.3.104~),
 libgles-dev,
 libglew-dev,
 libgsm1-dev,
 libmbedtls-dev,
 libopus-dev,
 libpcap-dev,
 libpulse-dev,
 libspandsp-dev,
 libspeex-dev,
 libspeexdsp-dev,
 libsqlite3-dev,
 libsrtp2-dev [!hurd-any !sparc],
 libswscale-dev (>= 6:10~),
 libtheora-dev,
 libturbojpeg0-dev,
 libupnp-dev,
 libv4l-dev [linux-any],
 libvpx-dev,
 libx11-dev,
 libxext-dev,
 libxml2-dev,
 libxv-dev,
 libzxing-dev,
 mesa-common-dev,
 pkgconf,
 qtbase5-dev,
 qtdeclarative5-dev,
 xxd,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: libs
Homepage: https://www.linphone.org/technical-corner/mediastreamer2/overview
Vcs-Git: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2.git
Vcs-Browser: https://salsa.debian.org/pkg-voip-team/linphone-stack/mediastreamer2
Description: Multimedia streaming engine for telephony

Package: libmediastreamer2-14
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 libmediastreamer-data (= ${source:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 mediastreamer2-plugin-msqogl,
 mediastreamer2-plugin-opencore-amr,
 mediastreamer2-plugin-openh264,
 mediastreamer2-plugin-webrtc,
 mediastreamer2-plugin-x264,
Suggests:
 mediastreamer2-plugin-codec2,
Description: Voice and video streaming engine for telephony (base)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the base library.

Package: libmediastreamer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libbctoolbox-dev,
 libmediastreamer2-14 (= ${binary:Version}),
# the .pc file mentions these 2, so a Depends: is needed
# also the headers reference files from these 2
 libortp-dev,
 ${misc:Depends},
Description: Development files for the mediastreamer2 library
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the development files for the development library.

Package: libmediastreamer-tools
Architecture: any
Multi-Arch: no
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (programs)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains some programs using the library.

Package: libmediastreamer-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Description: Voice and video streaming engine for telephony (data files)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains architecture-independent data files.

Package: libmediastreamer-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Description: Voice and video streaming engine for telephony (documentation)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains the developer documentation.

Package: mediastreamer2-plugin-msqogl
Conflicts:
 libmediastreamer12,
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Voice and video streaming engine for telephony (OpenGL)
 Mediastreamer2 is a powerful and lightweight streaming engine
 specially designed for voice/video telephony applications.
 .
 This open source library is responsible for all receiving and
 sending of multimedia streams in Linphone, including voice/video
 capture, encoding, decoding, and rendering.
 .
 This package contains a plugin needed for OpenGL-accelerated video
 telephony support.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk
export DEB_VERSION_UPSTREAM

DEB_REQUESTED_PACKAGES := $(shell dh_listpackages)
when-in-build-profile     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-not-in-build-profile = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_BUILD_PROFILES))))))
when-building-package     = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 01,1,0$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))
when-not-building-package = $(patsubst 0,$(3),$(patsubst 1,$(2),$(patsubst 11,0,1$(patsubst $(1),1,$(filter $(1),$(DEB_REQUESTED_PACKAGES))))))

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# Obtain the list of non-builtin targets once the Makefile has been
# generated.  If anyone knows of a better way, tell me!
ifneq (,$(wildcard obj-$(DEB_HOST_GNU_TYPE)/Makefile))
cmaketargets := $(shell find obj-$(DEB_HOST_GNU_TYPE) -type d -name '*.dir' -printf ' %f\n'|sed 's@.dir$$@@'|sort -u)
indeptargets := $(filter mediastreamer2-html-doc,$(cmaketargets))
archtargets := $(filter-out mediastreamer2-html-doc,$(cmaketargets))
endif

libpkgname := libmediastreamer2-14

features += -DENABLE_TOOLS=$(call when-building-package,libmediastreamer-tools,YES,NO)
features += -DENABLE_UNIT_TESTS=no
features += -DBUILD_SHARED_LIBS=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_G729=$(call when-building-package,$(libpkgname),YES,NO) # libbcg729-dev
features += -DENABLE_G729B_CNG=$(call when-building-package,$(libpkgname),YES,NO) #  libbcg729-dev
features += -DENABLE_JPEG=$(call when-building-package,$(libpkgname),YES,NO) # libturbojpeg0-dev
features += -DENABLE_QRCODE=$(call when-building-package,$(libpkgname),YES,NO) # libzxingcore-dev
features += -DENABLE_PCAP=$(call when-building-package,$(libpkgname),YES,NO) # libpcap-dev
features += -DENABLE_G726=$(call when-building-package,$(libpkgname),YES,NO) # libspandsp-dev
features += -DENABLE_GSM=$(call when-building-package,$(libpkgname),YES,NO) # libgsm1-dev
features += -DENABLE_SRTP=$(call when-building-package,$(libpkgname),YES,NO) # libsrtp2-dev
features += -DENABLE_ZRTP=$(call when-building-package,$(libpkgname),YES,NO) # libbzrtp-dev
features += -DENABLE_MKV=$(call when-building-package,$(libpkgname),YES,NO) # libbcmatroska2-dev
features += -DENABLE_BV16=NO # $(call when-building-package,$(libpkgname),YES,NO) # libbv16-dev
features += -DENABLE_FFMPEG=$(call when-building-package,$(libpkgname),YES,NO) # libavcodec-dev libavutil-dev
features += -DENABLE_SOUND=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_ALSA=$(call when-building-package,$(libpkgname),YES,NO) # libasound2-dev
features += -DENABLE_SPEEX_CODEC=$(call when-building-package,$(libpkgname),YES,NO) # libspeex-dev
features += -DENABLE_SPEEX_DSP=$(call when-building-package,$(libpkgname),YES,NO) # libspeexdsp-dev
features += -DENABLE_OPUS=$(call when-building-package,$(libpkgname),YES,NO) # libopus-dev
features += -DENABLE_PULSEAUDIO=$(call when-building-package,$(libpkgname),YES,NO) # libpulse-dev
features += -DENABLE_VIDEO=$(call when-building-package,$(libpkgname),YES,NO)
features += -DENABLE_THEORA=$(call when-building-package,$(libpkgname),YES,NO) # libtheora-dev
features += -DENABLE_QT_GL=$(call when-building-package,$(libpkgname),YES,NO) # qtdeclarative5-dev qtbase5-dev
# Under http://linphone.org/technical-corner/mediastreamer2?qt-technical_corner=3#qt-technical_corner
# it reads now (2021): "Please refer to public header files for
# Mediastreamer2 documentation."  I guess that means the docs are not
# considered worth maintaining anymore, but for now we still ship them.
features += -DENABLE_DOC=$(call when-building-package,libmediastreamer-doc,YES,NO) # doxygen

# Upstream unconditionally sets CMAKE_INSTALL_RPATH. Make it ineffective by
# setting CMAKE_SKIP_RPATH
options += -DCMAKE_SKIP_RPATH=ON
options += -DGIT_EXECUTABLE=/usr/share/bctoolbox/upstream-version-from-changelog
options += -DDEB_VERSION_UPSTREAM=$(DEB_VERSION_UPSTREAM:%+dfsg=%)
options += -DDISABLE_OPERATE_ON_SOURCE_CODE=$(call when-building-package,$(libpkgname),NO,YES)

# note that CMAKE_INSTALL_DATADIR must be an /absolute/ path here
# whereas in e.g. liblinphone it must be a path relative to /usr
options += -DCMAKE_INSTALL_DATADIR="/usr/share/mediastreamer2" # nowebcamCIF.jpg must go into images/ here

%:
	dh $@ --buildsystem=cmake --without autoreconf

override_dh_auto_configure:
	if ! [ -f debian/$(libpkgname).install ]; then \
		echo "HINT: You must update d/rules to have the new soname!" | grep --color '^.*$$' >&2 ; \
		false ; \
	fi
	dh_auto_configure -O--buildsystem=cmake -- \
	${features} \
	${options}

execute_before_dh_auto_install-indep:
ifeq (x,$(call when-not-building-package,libmediastreamer-dev,x))
	cp obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake \
	   obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake.orig
	truncate -s 0 obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake
endif

execute_after_dh_auto_install-indep:
ifeq (x,$(call when-not-building-package,libmediastreamer-dev,x))
	mv obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake.orig \
	   obj-$(DEB_HOST_GNU_TYPE)/include/cmake_install.cmake
endif

execute_before_dh_install-indep:
	mkdir -p debian/tmp/usr/share/mediastreamer2/images && \
		cp -afv src/voip/nowebcamCIF.jpg debian/tmp/usr/share/mediastreamer2/images/nowebcamCIF.jpg

override_dh_auto_build-arch:
	dh_auto_build -O--buildsystem=cmake -- $(archtargets)

execute_after_dh_auto_build-arch:
#	false

override_dh_auto_build-indep:
# this tests for the -doc package only since the -data package needs
# nothing built
ifeq (x,$(call when-building-package,libmediastreamer-doc,x))
	echo DEB_HOST_GNU_TYPE=$(DEB_HOST_GNU_TYPE) DEB_HOST_MULTIARCH=$(DEB_HOST_MULTIARCH)
	sed -i 's@^HAVE_DOT.*NO$$@HAVE_DOT = YES@' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	sed -i 's@^RECURSIVE .*NO$$@RECURSIVE = YES@' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	sed -i 's@^PREDEFINED .*= DOXYGEN \\$$@PREDEFINED = DOXYGEN MS2_DEPRECATED= \\@#Doxygen cannot parse __attribute__() expressions' obj-$(DEB_HOST_GNU_TYPE)/help/Doxyfile
	dh_auto_build -O--buildsystem=cmake -- $(call when-building-package,libmediastreamer-doc,mediastreamer2-html-doc)
endif

override_dh_auto_clean:
	dh_auto_clean -O--buildsystem=cmake
